#from GPL.txt import *
"""
(c) nd@felinemenace.org/FelineMenace 2003
HOON
a simple ATT syntax asm parser
neet tokening system (without going overboard on a huge independant parser :|)
needs a bit of work on the more difficult instructions like (movl 0xc(%eax),%ebx)
and heaps more instruction definitions and labels and calls/jmps :\.
so it needs heaps of works!
"""

from struct import pack

class HOON:
	# so much stuff, so little time!
	def __init__(self,raw=""):
		self.tokens = []

		# common delimeters
		self.instruction_sep = ","
		self.value_sep = "$"
		self.register_sep = "%"
		self.colon = ":"
		self.hex = "0x"
		self.space = "\x20"
		self.newline = "\x0a"
		self.null = "\x00"
		self.hash = "#"
		self.base = "\xc0"
		# our registers! note how al,ah are missing! :<
		self.reglist=["%eax","%ecx","%edx","%ebx","%esp","%ebp","%esi","%edi"]
		self.single = {}
		self.ins = {}
		self.format = {}
		self.insformat = {}
		self.fmtarray = []
		
		# start inside the start!
		if raw != "":
			return self.init(raw)
	
	def run(self,raw):
		return self.init(raw)

	# __init__ or init? hehehe.
	def init(self,raw):
		self.fmt()
		# i spose the last value could be a opcode or a beginning possition
		# like inc %eax is 0x40 and it goes up by one. 0x40 is the beginning
		# and the rest are added to the base. most of the bases are the instructions
		# that use or manipulate %eax
		self.addreg("pushl",self.format["inshex"],"\x68")
		self.addreg("pushl",self.format["insdec"],"\x68")
		self.addreg("pushl",self.format["insreg"],"\x50")

		self.addreg("cdql",self.format["single"],"\x99")
		self.addreg("int3",self.format["single"],"\xcc")
		self.addreg("nop",self.format["single"],"\x90")
		self.addreg("int",self.format["inshex"],"\xcd")
		self.addreg("ret",self.format["single"],"\xc3")

		self.addreg("inc",self.format["insreg"],"\x40")
		self.addreg("incl",self.format["insreg"],"\x40")

		self.addreg("movl",self.format["insdecreg"],"\xc7%s" % self.base)
		self.addreg("movl",self.format["insregreg"],"\x8b%s" % self.base)

		self.addreg("xorl",self.format["insregreg"],"\x33%s" % self.base)
		self.addreg("xor",self.format["insregreg"],"\x33%s" % self.base)

		self.addreg("popl",self.format["insreg"],"\x58")
		self.addreg("pop",self.format["insreg"],"\x58")
		
		self.addreg("test",self.format["insregreg"],"\x85%s" % self.base)
		
		# parse it up!
		return self.parse(raw)

	# every piece of python's favourite method!
	# horrible sentence that.
	def isint(self,str):
		try:
			num = int(str,0)
			return 1
		except ValueError:
			return 0
	
	# housecleaning
	def fixup(self,raw):
		temp = []
		for x in raw:
			if x != "" and not x.startswith(self.hash):
				#print x
				temp.append(x)
		return temp

	# build the tokens. pretty simple really :/
	# the format's they create are global really and are used to build the shellcode later on
	def parse(self,raw):
		raw = self.fixup(raw)
		temp = []
		rest = ""
		temp1 = ""
		for x in raw:
			buf = ""
			if x.count(self.space) < 1 and x.count(self.instruction_sep) < 1:
				buf = "[SINGLE]"
			else:
				if x.find(self.space) != -1:
					(instruction,rest) = x.split(self.space)
				buf += "[INSTRUCTION] "
				temp = rest.split(self.instruction_sep)
				for t in temp:
					if t.startswith(self.value_sep):
						temp1 = t[1:3]
						if temp1 == self.hex:
							buf += "[HEXADECIMAL] "
						else:
							buf += "[DECIMAL] "
					elif t.startswith(self.register_sep):
						buf += "[REGISTER] "
					else:
						buf += "[UNKNOWN] "
				# \x20 havok!
				buf = buf[0:-1]
			self.tokens.append(buf)
		print "<-- TOKENS -->"
		x = 0
		while x < len(self.tokens):
			print self.tokens[x] + " : " + raw[x]
			x += 1
		print "<-- ENDTOKEN -->\n"
		return self.build(raw)
	
	# add a instruction definition to the list
	# im not going to change the name now it's working!
	def addreg(self,ins,fmt,opc):
		#print "ins:%s - fmt:%s - opc:\\x%x" % (ins,fmt,ord(opc))
		if fmt == self.format["single"]:
			self.single[ins] = opc
			self.insformat[ins] = fmt
		else:
			if self.ins.has_key(ins):
				self.ins[ins] += "%s%s" % (self.colon,opc)
				self.insformat[ins] += "%s%s" % (self.colon,fmt)
			else:
				self.ins[ins] = opc
				self.insformat[ins] = fmt
	
	# overkill? i think so!
	def fmt(self):
		self.format["inshexreg"] = "[INSTRUCTION] [HEXADECIMAL] [REGISTER]"
		self.format["insdecreg"] = "[INSTRUCTION] [DECIMAL] [REGISTER]"
		self.format["insreg"] = "[INSTRUCTION] [REGISTER]"
		self.format["single"] = "[SINGLE]"
		self.format["insdec"] = "[INSTRUCTION] [DECIMAL]"
		self.format["inshex"] = "[INSTRUCTION] [HEXADECIMAL]"
		self.format["insregreg"] = "[INSTRUCTION] [REGISTER] [REGISTER]"
		
		self.fmtarray.append("[INSTRUCTION] [HEXADECIMAL] [REGISTER]")
		self.fmtarray.append("[INSTRUCTION] [DECIMAL] [REGISTER]")
		self.fmtarray.append("[INSTRUCTION] [REGISTER]")
		self.fmtarray.append("[SINGLE]")
		self.fmtarray.append("[INSTRUCTION] [DECIMAL]")
		self.fmtarray.append("[INSTRUCTION] [HEXADECIMAL]")
		self.fmtarray.append("[INSTRUCTION] [REGISTER] [REGISTER]")

	# build the code from the tokens and the raw data
	def build(self,raw):
		sc = ""
		built = ""
		if self.tokens == []:
			print "use parse first"
			return 0
		if len(self.tokens) != len(raw):
			print "error in sizes"
			return 0
		x = 0
		for t in self.tokens:
			for z in self.fmtarray:
				if t == z:
					if t == self.format["single"]:
						print raw[x]
						sc += self.single[raw[x]]

					elif t == self.format["inshex"] or t == self.format["insdec"]:
						(one,two) = raw[x].split(self.space)
						# get rid of $
						i = two[1:]
						val = self.getins(one,t)
						sc += (val + pack('<H',int(i,0))).strip(self.null)

					elif t == self.format["insreg"]:
						(one,two) = raw[x].split(self.space)
						three = self.getins(one,t)
						sc += chr(ord(three) + self.regpos(two))
					
					# i hate if's as much as the next bloke!
					elif t == self.format["inshexreg"] or t == self.format["insdecreg"]:
						(one,two) = raw[x].split(self.space)
						(three,four) = two.split(self.instruction_sep)
						three = three[1:]
						first = self.ins[one]
						if self.isint(three):
							i = pack('<l',int(three,0))
						else:
							print "not an integer!"
							pass
						sc += first[0] + chr(ord(first[1]) + self.regpos(four)) + i

					elif t == self.format["insregreg"]:
						(one,two) = raw[x].split(self.space)
						(three,four) = two.split(self.instruction_sep)
						first = self.getins(one,t)
						second = first[1]
						sc += first[0] + chr(ord(second) + ((self.regpos(three) * 8) + self.regpos(four)))
			x += 1
		for x in sc:
			built += "\\x%2.2x" % ord(x)
		print "<-- SHELLCODE -->"
		print "char sc[]=\"%s\";" % built
		print "<-- ENDSHELLCODE -->"
		return sc
	
	def regpos(self,reg):
		x = 0
		for x in range(0,len(self.reglist)):
			if self.reglist[x] == reg:
				return x
		return 0
	
	# get the register if there are multiple definitions!
	def getins(self,ins,fmt):
		insbuf = []
		fmtbuf = []
		x = 0
		if self.ins[ins].count(self.colon) > 0 and self.insformat[ins].count(self.colon) > 0:
 			insbuf = self.ins[ins].split(self.colon)
			fmtbuf = self.insformat[ins].split(self.colon)
		else:
			return self.ins[ins]
		while x < len(fmtbuf):
			if fmtbuf[x] == fmt:
				return insbuf[x]
			x += 1
		print "not found!"
		return ""

# :>
if __name__=='__main__':
	import sys
	s = HOON()
	sc = s.run(open(sys.argv[1],"r").read().split('\n'))
	#print len(sc)
					
